/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch32v20x_it.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2023/12/29
 * Description        : Main Interrupt Service Routines.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/
#include "ch32v20x_it.h"

void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void DMA1_Channel4_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void DMA1_Channel5_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{
  while (1)
  {
  }
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
  while (1)
  {
  }
}
//i2c2 tx
void DMA1_Channel4_IRQHandler()
{
    if( DMA_GetITStatus(DMA1_IT_TC4) != RESET )
    {
        DMA_Cmd( DMA1_Channel4, DISABLE );
        DMA_ClearITPendingBit(DMA1_IT_TC4);
        I2C_GenerateSTOP( I2C2, ENABLE );
        printf("DMA1_Channel4_IRQHandler\r\n");
    }
}
//i2c2 rx
void DMA1_Channel5_IRQHandler()
{
    I2C_GenerateSTOP( I2C2, ENABLE );
    //printf("DMA1_Channel5_IRQHandler");
    if( DMA_GetITStatus(DMA1_IT_TC5) != RESET )
    {

        DMA_Cmd( DMA1_Channel5, DISABLE );
        DMA_ClearITPendingBit(DMA1_IT_TC5);

        printf("DMA1_Channel5_IRQHandler\r\n");
    }
}

