/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/*
 *@Note
 *USART Print debugging routine:
 *USART1_Tx(PA9).
 *This example demonstrates using USART1(PA9) as a print debug port output.
 *
 */

#include "debug.h"
#include "logan_i2c2.h"
#include "logan_gpio.h"
#include "logan_NVIC.H"
#include "logan_dma.h"

/* Global typedef */
#define Size   2
/* Global define */

/* Global Variable */
/* Global Variable */
u8 TxData[Size] = { 0x03, 0xFF};
u8 RxData[10];
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    logan_inic_NVIC();
    SystemCoreClockUpdate();
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
    printf("This is printf example\r\n");

    logan_IIC2_Init(100000, 0x01);
//    logan_DMA_I2C2_TX_Init((u32)TxData, 3);
    //logan_DMA_I2C2_RX_Init((u32)RxData, Size);
//    logan_i2c2_tx(0x5b);
    logan_DMA_I2C2_RX_Init((u32)RxData,1);
    logan_i2c2_rx(0x5b, 0x12);

//    for( u8 i = 0; i < 6; i++ )
//    {
//      printf( "%02x \r\n", RxData[i] );
//      RxData[i] =0;
//    }
//      printf( "\r\n ");



    while(1)
    {

        Delay_Ms(500);
        printf( "qqqqq\r\n ");
    }
}
